Summary: A dynamic OpenSSL engine for IBMCA
Name: openssl-ibmca
Version: 1.0.0.rc2
Release: 2%{?dist}
License: IBM Public License
Group: System Environment/Libraries
URL: http://sourceforge.net/projects/opencryptoki
Source: openssl-ibmca-1.0.0.rc2.tar.bz2
Patch1: openssl-ibmca-1.0.0.rc2-libcrypto.patch
Patch2: openssl-ibmca-1.0.0.rc2-sw.patch
Patch3: openssl-ibmca-1.0.0.rc2-memset.patch
Patch4: openssl-ibmca-1.0.0.rc2-segfault.patch
Patch5: openssl-ibmca-1.0-async-crypto-large-keys-fallback.patch
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: openssl >= 0.9.8
BuildRequires: openssl-devel libica-devel automake libtool
ExclusiveArch: s390 s390x

%description
A dynamic OpenSSL engine for IBMCA crypto hardware on IBM zSeries machines.

%prep
%setup -q -n openssl-ibmca-1.0.0-rc2
%patch1 -p1 -b .libcrypto
%patch2 -p1 -b .sw
%patch3 -p1 -b .memset
%patch4 -p1 -b .segfault
%patch5 -p1 -b .large-keys
autoreconf -f -i -s

%build
%configure
make

%install
if [[ $RPM_BUILD_ROOT  ]] ;
then
        export INSROOT=$RPM_BUILD_ROOT
fi
%makeinstall

# AutoFOO seems to confuse the libdir stuff, so we need to move the files
# to the proper location manually. sigh.
install -d $RPM_BUILD_ROOT/%{_libdir}/openssl/engines
mv $RPM_BUILD_ROOT/%{_libdir}/libibmca.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/openssl/engines
ln -sf libibmca.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/openssl/engines/libibmca.so.0.0
ln -sf libibmca.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/openssl/engines/libibmca.so.0
ln -sf libibmca.so.0.0.0 $RPM_BUILD_ROOT/%{_libdir}/openssl/engines/libibmca.so

rm -f $RPM_BUILD_ROOT/%{_libdir}/libibmca*

%files
%defattr(-,root,root)
%doc openssl.cnf.sample
%{_libdir}/openssl/engines/libibmca.so*

%clean
rm -rf $RPM_BUILD_ROOT

%changelog
* Thu Aug 19 2010 Dan Horák <dhorak@redhat.com> - 1.0.0rc2-2.el5
- allow key length of 4096 for RSA (#597394)
- Resolves: #597394

* Thu Jun 21 2007 Phil Knirsch <pknirsch@redhat.com> - 1.0.0rc2-1.el5.4
- Fixed several issues with failure of using ibmca engine (#227644)

* Tue Dec 12 2006 Phil Knirsch <pknirsch@redhat.com> - 1.0.0rc2-1.el5.3
- Added missing symlinks for libs (#215735)
- Added samle config file (#215735)

* Thu Nov 23 2006 Phil Knirsch <pknirsch@redhat.com> - 1.0.0rc2-1.el5.2
- Necessary fix so openssl finds the module properly (#215735)

* Thu May 11 2006 Phil Knirsch <pknirsch@redhat.com> - 1.0.0rc2
- Initial package.
